<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output 
		method="xml" 
		encoding="ISO-8859-1"
		 indent="yes" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
		 doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
		 media-type="text/xml"
		 omit-xml-declaration="no"
		 version="1.0"/>

  <!-- default values -->
  <xsl:param name="theCountry" select="'Frankrike'"/>
 	<xsl:param name="theType" select="'red'"/>


	<xsl:template match="/">
		<html>
		<head>
			<title>Vinliste</title>
			<link rel="STYLESHEET" href="vin.css"/>
		</head>
		<body>
		<h1>Vinliste</h1>
		
		<xsl:variable name="list" 
                  select="//wine[country=$theCountry  and type=$theType]"/>
		
		<p>
		<xsl:value-of select="count($list)"/> viner
		</p>
      
		<hr/>

		<xsl:apply-templates select="$list">
			<xsl:sort select="type" order="ascending"/>
			<xsl:sort select="dice" order="descending"/>
			<xsl:sort select="price/volume" order="descending"/>
		</xsl:apply-templates>

		</body>
		</html>
	</xsl:template>


	<xsl:template match="//wine">
		<div class="wine">
		<div style="float:left">
		<xsl:element name="img">
			<xsl:attribute name="src"><xsl:value-of 
        select="type"/><xsl:value-of 
          select="dice"/>.gif</xsl:attribute>
			<xsl:attribute name="alt">dice</xsl:attribute>
		</xsl:element>
		</div>
		<div class="wine-name"><xsl:value-of select="name"/></div>
		<div class="wine-country"><xsl:value-of select="country"/></div>
		</div>
		<div style="clear:left"/>
		<div class="wine-desc"><xsl:value-of select="description"/></div>
		<div class="wine-price">
      NOK <xsl:value-of select="price"/> / <xsl:value-of select="volume"/>cl
    </div>
	</xsl:template>


</xsl:stylesheet>
