﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml.Xsl;
using System.IO;
using System.Xml;
using System.Text;
using System.Diagnostics;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            // fill the country box
            DropDownListCountry.Items.Add("Frankrike");
            DropDownListCountry.Items.Add("Italia");
            DropDownListCountry.Items.Add("Portugal");
            DropDownListCountry.Items.Add("Spania");
            DropDownListCountry.Items.Add("Chile");
            DropDownListCountry.Items.Add("Australia");
            DropDownListCountry.Items.Add("Tyskland");
            DropDownListCountry.Items.Add("Ungarn");
            DropDownListCountry.Items.Add("Argentina");
            DropDownListCountry.Items.Add("Sør-Afrika");
            DropDownListCountry.Items.Add("USA");
            DropDownListCountry.Items.Add("New Zealand");

        }
    }
    #region button1
    protected void UpdatePanel1_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            Literal1.Text = "<h3>Velg land og vintype</h3>";
            return;
        }       
        // fetch data
        String XmlSource =
                "http://www.ia.hiof.no/~borres/commondata/vin/viner.xml";
        // figure out what user has chosen
        String country = (String)DropDownListCountry.SelectedItem.ToString();
        String winetype = (String)DropDownListType.SelectedItem.ToString();

        // modify the selected string to match values on xml-file
        if (winetype.CompareTo("Musserende") == 0) winetype = "sparkling";
        else if (winetype.CompareTo("Rose") == 0) winetype = "rose";
        else if (winetype.CompareTo("Hvit") == 0) winetype = "white";
        else winetype = "red";

        // Access XML-file and perform transformation
        try
        {
            String physicalPath = 
                HttpContext.Current.Server.MapPath(".").ToString();


            // prepare the transformation
            XslCompiledTransform xslt = new XslCompiledTransform();
            xslt.Load(physicalPath + "\\App_Data\\tohtml_param.xslt");

            // set up an argumentlist with parameters
            XsltArgumentList argList = new XsltArgumentList();
            argList.AddParam("theCountry", "", country);
            argList.AddParam("theType", "", winetype);

            // Create a XmlWriter to stringbuffer 
            StringBuilder sb = new StringBuilder(4048);
            XmlWriter writer = XmlWriter.Create(sb);

            // Transform the file.
            xslt.Transform(XmlSource, argList, writer);
            writer.Flush();

            // pick relevant XML code as as text and display it
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(sb.ToString());
            String slist = doc.SelectSingleNode("//body").InnerXml;
            Literal1.Text = slist;
            writer.Close();

            // make a copy on disk for the pdf production
            XmlWriter fw = XmlWriter.Create(physicalPath + @"\output.html");
            doc.Save(fw);
            fw.Close();      
        }
        catch (Exception ex)
        {
            Literal1.Text = 
                String.Format(
                       "<div style=\"color:red\">Sorry, because: {0}</div>",
                       ex.Message);
        }

    }
    #endregion button1
    #region button2
    // make pdf
    protected void Button2_Click(object sender, EventArgs e)
    {
        String physicalPath =
                HttpContext.Current.Server.MapPath(".").ToString();
        // make pdf from the selected wines as saved in file
        string SOURCE_PATH = physicalPath + @"\output.html";
        string STYLE_PATH = physicalPath + @"\App_Data\report.css";
        String PRINCE_PATH = 
            Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) +
            @"\Prince\Engine\bin\prince.exe";
        // When testing on localhost:
        // String PRINCE_PATH =@"c:\fixed\Prince\Engine\bin\prince.exe";
        Process PP = new Process(); 
        try
        {
            PP.StartInfo.UseShellExecute = true;
            String args = "{0} -s {1}";
            PP.StartInfo.FileName = PRINCE_PATH;
            PP.StartInfo.Arguments =
                String.Format(args, SOURCE_PATH, STYLE_PATH);
            PP.StartInfo.CreateNoWindow = true;
            PP.Start();
            PP.WaitForExit();

            Panel1.Visible = true;
        }
        catch (Exception ex)
        {
            Label1.Text = "error: " + ex.Message;
            Panel1.Visible = false;
        }

        finally
        {
            if (PP != null)
            {
                PP.Close();
            }
        }
    }
    #endregion button2
}
